// Generated by gmmproc 2.37.7 -- DO NOT MODIFY!

#undef GDK_DISABLE_DEPRECATED
#define GDK_DISABLE_DEPRECATION_WARNINGS 1
 

#include <glibmm.h>

#include <gdkmm/display.h>
#include <gdkmm/private/display_p.h>

#include <gdk/gdk.h>

/*
 * Copyright 1998-2002 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <vector>

#include <gdkmm/applaunchcontext.h>
#include <gdkmm/devicemanager.h>
#include <gdkmm/window.h>
#include <gdk/gdk.h>

namespace Gdk
{

bool Display::set_selection_owner(const Glib::RefPtr<Window>& owner, Glib::ustring& selection, guint32 time_, bool send_event)
{
  return gdk_selection_owner_set_for_display(gobj(), owner->gobj(), Gdk::AtomUstring::to_c_type(selection), time_, (gboolean)send_event);
}

Glib::RefPtr<Window> Display::get_selection_owner(const Glib::ustring& selection)
{
  return Glib::wrap(gdk_selection_owner_get_for_display(gobj(), Gdk::AtomUstring::to_c_type(selection)) , true);
}

void Display::selection_send_notify(const Glib::RefPtr<Window>& requestor, Glib::ustring& selection, Glib::ustring& target, Glib::ustring& property, guint32 time_)
{
  gdk_selection_send_notify_for_display(gobj(), Glib::unwrap(requestor), Gdk::AtomUstring::to_c_type(selection), Gdk::AtomUstring::to_c_type(target), Gdk::AtomUstring::to_c_type(property), time_);
}

void Display::store_clipboard(const Glib::RefPtr<Gdk::Window>& clipboard_window, guint32 time_)
{
  gdk_display_store_clipboard(gobj(), clipboard_window->gobj(), time_, 0 /* see the C docs */, 0);
}

void Display::store_clipboard(const Glib::RefPtr<Gdk::Window>& clipboard_window, guint32 time_, const std::vector<Glib::ustring>& targets)
{
  if (!targets.size ())
  {
    gdk_display_store_clipboard(gobj(),
                                Glib::unwrap (clipboard_window),
                                time_,
                                Glib::ArrayHandler<Glib::ustring, AtomUstringTraits>::vector_to_array(targets).data (),
                                targets.size ());
  }
}

} //namespace Gdk

namespace
{


static void Display_signal_closed_callback(GdkDisplay* self, gboolean p0,void* data)
{
  using namespace Gdk;
  typedef sigc::slot< void,bool > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(p0
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
}

static const Glib::SignalProxyInfo Display_signal_closed_info =
{
  "closed",
  (GCallback) &Display_signal_closed_callback,
  (GCallback) &Display_signal_closed_callback
};


static const Glib::SignalProxyInfo Display_signal_opened_info =
{
  "opened",
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback,
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback
};


} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Gdk::Display> wrap(GdkDisplay* object, bool take_copy)
{
  return Glib::RefPtr<Gdk::Display>( dynamic_cast<Gdk::Display*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gdk
{


/* The *_Class implementation: */

const Glib::Class& Display_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Display_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gdk_display_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void Display_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* Display_Class::wrap_new(GObject* object)
{
  return new Display((GdkDisplay*)object);
}


/* The implementation: */

GdkDisplay* Display::gobj_copy()
{
  reference();
  return gobj();
}

Display::Display(const Glib::ConstructParams& construct_params)
:
  Glib::Object(construct_params)
{

}

Display::Display(GdkDisplay* castitem)
:
  Glib::Object((GObject*)(castitem))
{}


Display::~Display()
{}


Display::CppClassType Display::display_class_; // initialize static member

GType Display::get_type()
{
  return display_class_.init().get_type();
}


GType Display::get_base_type()
{
  return gdk_display_get_type();
}


Display::Display()
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Glib::Object(Glib::ConstructParams(display_class_.init()))
{
  

}

Glib::RefPtr<Display> Display::open(const Glib::ustring& display_name)
{

  Glib::RefPtr<Display> retvalue = Glib::wrap(gdk_display_open(display_name.c_str()));
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us
  return retvalue;
}


Glib::ustring Display::get_name() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gdk_display_get_name(const_cast<GdkDisplay*>(gobj())));
}

#ifndef GDKMM_DISABLE_DEPRECATED

int Display::get_n_screens() const
{
  return gdk_display_get_n_screens(const_cast<GdkDisplay*>(gobj()));
}

#endif // GDKMM_DISABLE_DEPRECATED

Glib::RefPtr<Screen> Display::get_screen(int screen_num)
{
  Glib::RefPtr<Screen> retvalue = Glib::wrap(gdk_display_get_screen(gobj(), screen_num));
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;
}

Glib::RefPtr<const Screen> Display::get_screen(int screen_num) const
{
  return const_cast<Display*>(this)->get_screen(screen_num);
}

Glib::RefPtr<Screen> Display::get_default_screen()
{
  Glib::RefPtr<Screen> retvalue = Glib::wrap(gdk_display_get_default_screen(gobj()));
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;
}

Glib::RefPtr<const Screen> Display::get_default_screen() const
{
  return const_cast<Display*>(this)->get_default_screen();
}

void Display::beep()
{
  gdk_display_beep(gobj());
}

void Display::sync()
{
  gdk_display_sync(gobj());
}

void Display::close()
{
  gdk_display_close(gobj());
}

bool Display::is_closed() const
{
  return gdk_display_is_closed(const_cast<GdkDisplay*>(gobj()));
}

GdkEvent* Display::get_event()
{
  return gdk_display_get_event(gobj());
}

const GdkEvent* Display::get_event() const
{
  return const_cast<Display*>(this)->get_event();
}

GdkEvent* Display::peek_event()
{
  return gdk_display_peek_event(gobj());
}

GdkEvent* Display::peek_event() const
{
  return const_cast<Display*>(this)->peek_event();
}

void Display::put_event(GdkEvent* event)
{
  gdk_display_put_event(gobj(), (const GdkEvent*)(event));
}

bool Display::has_pending() const
{
  return gdk_display_has_pending(const_cast<GdkDisplay*>(gobj()));
}

#ifndef GDKMM_DISABLE_DEPRECATED

void Display::set_double_click_time(guint msec)
{
  gdk_display_set_double_click_time(gobj(), msec);
}

#endif // GDKMM_DISABLE_DEPRECATED

#ifndef GDKMM_DISABLE_DEPRECATED

void Display::set_double_click_distance(guint distance)
{
  gdk_display_set_double_click_distance(gobj(), distance);
}

#endif // GDKMM_DISABLE_DEPRECATED

Glib::RefPtr<Display> Display::get_default()
{

  Glib::RefPtr<Display> retvalue = Glib::wrap(gdk_display_get_default());
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us
  return retvalue;
}


Glib::RefPtr<Display> Display::open_default_libgtk_only()
{

  Glib::RefPtr<Display> retvalue = Glib::wrap(gdk_display_open_default_libgtk_only());
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us
  return retvalue;
}


GdkKeymap* Display::get_keymap()
{
  return gdk_keymap_get_for_display(gobj());
}

const GdkKeymap* Display::get_keymap() const
{
  return const_cast<Display*>(this)->get_keymap();
}

void Display::flush()
{
  gdk_display_flush(gobj());
}

bool Display::supports_cursor_alpha() const
{
  return gdk_display_supports_cursor_alpha(const_cast<GdkDisplay*>(gobj()));
}

bool Display::supports_cursor_color() const
{
  return gdk_display_supports_cursor_color(const_cast<GdkDisplay*>(gobj()));
}

guint Display::get_default_cursor_size() const
{
  return gdk_display_get_default_cursor_size(const_cast<GdkDisplay*>(gobj()));
}

void Display::get_maximal_cursor_size(guint& width, guint& height)
{
  gdk_display_get_maximal_cursor_size(gobj(), &(width), &(height));
}

Glib::RefPtr<Window> Display::get_default_group()
{
  Glib::RefPtr<Window> retvalue = Glib::wrap(gdk_display_get_default_group(gobj()));
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;
}

Glib::RefPtr<const Window> Display::get_default_group() const
{
  return const_cast<Display*>(this)->get_default_group();
}

bool Display::supports_selection_notification() const
{
  return gdk_display_supports_selection_notification(const_cast<GdkDisplay*>(gobj()));
}

bool Display::request_selection_notification(const Glib::ustring& selection)
{
  return gdk_display_request_selection_notification(gobj(), Gdk::AtomString::to_c_type(selection));
}

bool Display::supports_clipboard_persistence() const
{
  return gdk_display_supports_clipboard_persistence(const_cast<GdkDisplay*>(gobj()));
}

bool Display::supports_shapes() const
{
  return gdk_display_supports_shapes(const_cast<GdkDisplay*>(gobj()));
}

bool Display::supports_input_shapes() const
{
  return gdk_display_supports_input_shapes(const_cast<GdkDisplay*>(gobj()));
}

bool Display::supports_composite() const
{
  return gdk_display_supports_composite(const_cast<GdkDisplay*>(gobj()));
}

void Display::notify_startup_complete(const Glib::ustring& startup_id)
{
  gdk_display_notify_startup_complete(gobj(), startup_id.c_str());
}

Glib::RefPtr<DeviceManager> Display::get_device_manager()
{
  Glib::RefPtr<DeviceManager> retvalue = Glib::wrap(gdk_display_get_device_manager(gobj()));
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;
}

Glib::RefPtr<const DeviceManager> Display::get_device_manager() const
{
  return const_cast<Display*>(this)->get_device_manager();
}

Glib::RefPtr<AppLaunchContext> Display::get_app_launch_context()
{
  Glib::RefPtr<AppLaunchContext> retvalue = Glib::wrap(gdk_display_get_app_launch_context(gobj()));
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;
}

Glib::RefPtr<const AppLaunchContext> Display::get_app_launch_context() const
{
  return const_cast<Display*>(this)->get_app_launch_context();
}


Glib::SignalProxy1< void,bool > Display::signal_closed()
{
  return Glib::SignalProxy1< void,bool >(this, &Display_signal_closed_info);
}


Glib::SignalProxy0< void > Display::signal_opened()
{
  return Glib::SignalProxy0< void >(this, &Display_signal_opened_info);
}


} // namespace Gdk


